package net.mcreator.puzzle_code.client.gui;

import net.neoforged.neoforge.network.PacketDistributor;

import net.minecraft.world.level.Level;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.chat.Component;
import net.minecraft.client.gui.screens.inventory.AbstractContainerScreen;
import net.minecraft.client.gui.components.WidgetSprites;
import net.minecraft.client.gui.components.ImageButton;
import net.minecraft.client.gui.GuiGraphics;

import net.mcreator.puzzle_code.world.inventory.SwitcherBlockGUIMenu;
import net.mcreator.puzzle_code.procedures.RedstoneReactDisplayOffProcedure;
import net.mcreator.puzzle_code.procedures.ClickingReactDisplayOffProcedure;
import net.mcreator.puzzle_code.network.SwitcherBlockGUIButtonMessage;

import java.util.HashMap;

import com.mojang.blaze3d.systems.RenderSystem;

public class SwitcherBlockGUIScreen extends AbstractContainerScreen<SwitcherBlockGUIMenu> {
	private final static HashMap<String, Object> guistate = SwitcherBlockGUIMenu.guistate;
	private final Level world;
	private final int x, y, z;
	private final Player entity;
	ImageButton imagebutton_question_mark_button;
	ImageButton imagebutton_on_button;
	ImageButton imagebutton_off_button;
	ImageButton imagebutton_on_button1;
	ImageButton imagebutton_off_button1;
	ImageButton imagebutton_question_mark_button1;

	public SwitcherBlockGUIScreen(SwitcherBlockGUIMenu container, Inventory inventory, Component text) {
		super(container, inventory, text);
		this.world = container.world;
		this.x = container.x;
		this.y = container.y;
		this.z = container.z;
		this.entity = container.entity;
		this.imageWidth = 176;
		this.imageHeight = 89;
	}

	private static final ResourceLocation texture = ResourceLocation.parse("puzzle_code:textures/screens/switcher_block_gui.png");

	@Override
	public void render(GuiGraphics guiGraphics, int mouseX, int mouseY, float partialTicks) {
		this.renderBackground(guiGraphics, mouseX, mouseY, partialTicks);
		super.render(guiGraphics, mouseX, mouseY, partialTicks);
		this.renderTooltip(guiGraphics, mouseX, mouseY);
		if (mouseX > leftPos + 51 && mouseX < leftPos + 71 && mouseY > topPos + 22 && mouseY < topPos + 42)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.switcher_block_gui.tooltip_nbt_clickingreact"), mouseX, mouseY);
		if (mouseX > leftPos + 51 && mouseX < leftPos + 71 && mouseY > topPos + 58 && mouseY < topPos + 78)
			guiGraphics.renderTooltip(font, Component.translatable("gui.puzzle_code.switcher_block_gui.tooltip_nbt_redstonereact"), mouseX, mouseY);
	}

	@Override
	protected void renderBg(GuiGraphics guiGraphics, float partialTicks, int gx, int gy) {
		RenderSystem.setShaderColor(1, 1, 1, 1);
		RenderSystem.enableBlend();
		RenderSystem.defaultBlendFunc();
		guiGraphics.blit(texture, this.leftPos, this.topPos, 0, 0, this.imageWidth, this.imageHeight, this.imageWidth, this.imageHeight);
		RenderSystem.disableBlend();
	}

	@Override
	public boolean keyPressed(int key, int b, int c) {
		if (key == 256) {
			this.minecraft.player.closeContainer();
			return true;
		}
		return super.keyPressed(key, b, c);
	}

	@Override
	protected void renderLabels(GuiGraphics guiGraphics, int mouseX, int mouseY) {
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.switcher_block_gui.label_does_react_when_clicked"), 6, 9, -12829636, false);
		guiGraphics.drawString(this.font, Component.translatable("gui.puzzle_code.switcher_block_gui.label_does_react_with_redstone"), 6, 45, -12829636, false);
	}

	@Override
	public void init() {
		super.init();
		imagebutton_question_mark_button = new ImageButton(this.leftPos + 51, this.topPos + 22, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button", imagebutton_question_mark_button);
		this.addRenderableWidget(imagebutton_question_mark_button);
		imagebutton_on_button = new ImageButton(this.leftPos + 6, this.topPos + 22, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/on_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/on_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new SwitcherBlockGUIButtonMessage(1, x, y, z));
						SwitcherBlockGUIButtonMessage.handleButtonAction(entity, 1, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_on_button", imagebutton_on_button);
		this.addRenderableWidget(imagebutton_on_button);
		imagebutton_off_button = new ImageButton(this.leftPos + 6, this.topPos + 22, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/off_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/off_button_highlight.png")), e -> {
					if (ClickingReactDisplayOffProcedure.execute(world, x, y, z)) {
						PacketDistributor.sendToServer(new SwitcherBlockGUIButtonMessage(2, x, y, z));
						SwitcherBlockGUIButtonMessage.handleButtonAction(entity, 2, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				if (ClickingReactDisplayOffProcedure.execute(world, x, y, z))
					guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_off_button", imagebutton_off_button);
		this.addRenderableWidget(imagebutton_off_button);
		imagebutton_on_button1 = new ImageButton(this.leftPos + 6, this.topPos + 58, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/on_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/on_button_highlight.png")), e -> {
					if (true) {
						PacketDistributor.sendToServer(new SwitcherBlockGUIButtonMessage(3, x, y, z));
						SwitcherBlockGUIButtonMessage.handleButtonAction(entity, 3, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_on_button1", imagebutton_on_button1);
		this.addRenderableWidget(imagebutton_on_button1);
		imagebutton_off_button1 = new ImageButton(this.leftPos + 6, this.topPos + 58, 40, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/off_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/off_button_highlight.png")), e -> {
					if (RedstoneReactDisplayOffProcedure.execute(world, x, y, z)) {
						PacketDistributor.sendToServer(new SwitcherBlockGUIButtonMessage(4, x, y, z));
						SwitcherBlockGUIButtonMessage.handleButtonAction(entity, 4, x, y, z);
					}
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				if (RedstoneReactDisplayOffProcedure.execute(world, x, y, z))
					guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_off_button1", imagebutton_off_button1);
		this.addRenderableWidget(imagebutton_off_button1);
		imagebutton_question_mark_button1 = new ImageButton(this.leftPos + 51, this.topPos + 58, 20, 20,
				new WidgetSprites(ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button.png"), ResourceLocation.parse("puzzle_code:textures/screens/question_mark_button_highlight.png")), e -> {
				}) {
			@Override
			public void renderWidget(GuiGraphics guiGraphics, int x, int y, float partialTicks) {
				guiGraphics.blit(sprites.get(isActive(), isHoveredOrFocused()), getX(), getY(), 0, 0, width, height, width, height);
			}
		};
		guistate.put("button:imagebutton_question_mark_button1", imagebutton_question_mark_button1);
		this.addRenderableWidget(imagebutton_question_mark_button1);
	}
}
